﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;
namespace Kendo.Models
{
    public class Accounts
    {
        #region Properties
        [ScaffoldColumn(false)]
        public int CompanyIdent { get; set; }
        [Required]
        public string AccountNumber { get; set; }
        [Required]
        public string CreditCardNumber { get; set; }
        [Required]
        public string DisplayName { get; set; }
        [Required]
        [DataType(DataType.Date)]
        public DateTime AsofDate { get; set; }
        #endregion
        public IEnumerable<Accounts> LoadAcounts()
        {
            var dsAccounts = RetrieveCompanyAccounts();
            foreach (DataRow accountRow in dsAccounts.Tables[0].Rows)
            {
                yield return new Accounts
                {
                    CompanyIdent = accountRow.IsNull("CompanyIdent") ? 0 : Convert.ToInt32(accountRow["CompanyIdent"]),
                    AccountNumber = accountRow.IsNull("AccountNumber") ? "" : (string)accountRow["AccountNumber"],
                    CreditCardNumber = accountRow.IsNull("ExternalAccountNumber_Encrypted") ? "" : (string)accountRow["ExternalAccountNumber_Encrypted"],
                    DisplayName = accountRow.IsNull("Display") ? string.Empty : (string)accountRow["Display"],
                    AsofDate = accountRow.IsNull("AsOfDate") ? DateTime.MinValue : (DateTime)accountRow["AsOfDate"],
                };
            }

        }
        public DataSet RetrieveCompanyAccounts()
        {
            var ds = new DataSet();
            var table = new DataTable("Prescription");
            table.Columns.Add("CompanyIdent", typeof(int));
            table.Columns.Add("AccountNumber", typeof(string));
            table.Columns.Add("ExternalAccountNumber_Encrypted", typeof(string));
            table.Columns.Add("Display", typeof(string));
            table.Columns.Add("AsOfDate", typeof(DateTime));

            table.Rows.Add(1, "100025", "", "David", DateTime.Now);
            table.Rows.Add(2, "100026", "", "Sam", DateTime.Now);
            table.Rows.Add(3, "100027", "", "Christoff", DateTime.Now);
            table.Rows.Add(4, "100028", "", "Janet", DateTime.Now);
            table.Rows.Add(5, "100029", "", "Melanie", DateTime.Now);
            table.Rows.Add(5, "100030", "", "Melanie", DateTime.Now);
            table.Rows.Add(5, "100031", "", "Melanie", DateTime.Now);
            table.Rows.Add(5, "100032", "", "Melanie", DateTime.Now);
            table.Rows.Add(5, "100033", "", "Melanie", DateTime.Now);
            table.Rows.Add(5, "100033", "", "Melanie", DateTime.Now);
            table.Rows.Add(5, "100034", "", "Melanie", DateTime.Now);
            table.Rows.Add(5, "100030", "", "Melanie", DateTime.Now);
            ds.Tables.Add(table);
            return ds;


        }

    }
}